Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/DTLZInstanceProvider.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/DTLZInstanceProvider.cs	(revision 14065)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/DTLZInstanceProvider.cs	(revision 14065)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
+  public class DTLZInstanceProvider : ProblemInstanceProvider<MOTFData> {
+
+    public override string Name {
+      get { return "DTLZ"; }
+    }
+
+    public override string Description {
+      get { return "DTLZ Problems"; }
+    }
+
+    public override Uri WebLink {
+      get { return new Uri("http://dev.heuristiclab.com/trac.fcgi/wiki/Documentation/Reference/Test%20Functions"); }
+    }
+
+    public override string ReferencePublication {
+      get { return "http://repository.ias.ac.in/81671/ [30.11.15]"; }
+    }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      var evaluators = ApplicationManager.Manager.GetInstances<DTLZ>().OrderBy(x => x.Name);
+      return evaluators.Select(x => new MOTFDataDescriptor(x));
+    }
+
+    public override MOTFData LoadData(IDataDescriptor id) {
+      var descriptor = (MOTFDataDescriptor)id;
+      return new MOTFData(descriptor);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/IHRInstanceProvider.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/IHRInstanceProvider.cs	(revision 14065)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/IHRInstanceProvider.cs	(revision 14065)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
+  public class IHRInstanceProvider : ProblemInstanceProvider<MOTFData> {
+
+    public override string Name {
+      get { return "IHR"; }
+    }
+
+    public override string Description {
+      get { return "IHR Problems"; }
+    }
+
+    public override Uri WebLink {
+      get { return new Uri("http://dev.heuristiclab.com/trac.fcgi/wiki/Documentation/Reference/Test%20Functions"); }
+    }
+
+    public override string ReferencePublication {
+      get { return "http://repository.ias.ac.in/81671/ [30.11.15]"; }
+    }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      var evaluators = ApplicationManager.Manager.GetInstances<IHR>().OrderBy(x => x.Name);
+      return evaluators.Select(x => new MOTFDataDescriptor(x));
+    }
+
+    public override MOTFData LoadData(IDataDescriptor id) {
+      var descriptor = (MOTFDataDescriptor)id;
+      return new MOTFData(descriptor);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MISCInstanceProvider.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MISCInstanceProvider.cs	(revision 14065)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MISCInstanceProvider.cs	(revision 14065)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
+  public class MISCInstanceProvider : ProblemInstanceProvider<MOTFData> {
+
+    public override string Name {
+      get { return "Miscellaneous"; }
+    }
+
+    public override string Description {
+      get { return "Miscellaneous Testfunctions"; }
+    }
+
+    public override Uri WebLink {
+      get { return new Uri("http://dev.heuristiclab.com/trac.fcgi/wiki/Documentation/Reference/Test%20Functions"); }
+    }
+
+    public override string ReferencePublication {
+      get { return String.Empty; }
+    }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      var evaluators = ApplicationManager.Manager.GetInstances<IMultiObjectiveTestFunction>()
+                                                 .Where(x => !Handled(x))
+                                                 .OrderBy(x => x.Name);
+      return evaluators.Select(x => new MOTFDataDescriptor(x));
+    }
+
+    private bool Handled(IMultiObjectiveTestFunction f) {
+      return f is DTLZ || f is ZDT || f is IHR;
+    }
+
+    public override MOTFData LoadData(IDataDescriptor id) {
+      var descriptor = (MOTFDataDescriptor)id;
+      return new MOTFData(descriptor);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MOTFData.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MOTFData.cs	(revision 14065)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MOTFData.cs	(revision 14065)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
+
+  /// <summary>
+  /// Describes instances of Multi Objective Test Functions (MOTF).
+  /// </summary>
+  public class MOTFData {
+    /// <summary>
+    /// The name of the instance
+    /// </summary>
+    public string Name { get; private set; }
+
+    /// <summary>
+    /// Optional! The description of the instance
+    /// </summary>
+    public string Description { get; private set; }
+
+    /// <summary>
+    /// The operator used for evaluations
+    /// </summary>
+    public IMultiObjectiveTestFunction TestFunction { get; private set; }
+
+    public MOTFData(string name, string description, IMultiObjectiveTestFunction testFunction) {
+      Name = name;
+      Description = description;
+      TestFunction = testFunction;
+    }
+
+    internal MOTFData(MOTFDataDescriptor descriptor) {
+      Name = descriptor.Name;
+      Description = descriptor.Description;
+      TestFunction = descriptor.TestFunction;
+    }
+  }
+
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MOTFDataDescriptor.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MOTFDataDescriptor.cs	(revision 14065)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/MOTFDataDescriptor.cs	(revision 14065)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
+  internal class MOTFDataDescriptor : IDataDescriptor {
+    public string Name { get { return TestFunction.ItemName + " Function"; } }
+
+    public string Description {
+      get { return TestFunction.Description; }
+    }
+
+    public IMultiObjectiveTestFunction TestFunction { get; private set; }
+
+    public MOTFDataDescriptor(IMultiObjectiveTestFunction testFunction) {
+      TestFunction = testFunction;
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/ZDTInstanceProvider.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/ZDTInstanceProvider.cs	(revision 14065)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Instances/ZDTInstanceProvider.cs	(revision 14065)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
+  public class ZDTInstanceProvider : ProblemInstanceProvider<MOTFData> {
+
+    public override string Name {
+      get { return "ZDT"; }
+    }
+
+    public override string Description {
+      get { return "ZDT Problems"; }
+    }
+
+    public override Uri WebLink {
+      get { return new Uri("http://dev.heuristiclab.com/trac.fcgi/wiki/Documentation/Reference/Test%20Functions"); }
+    }
+
+    public override string ReferencePublication {
+      get { return "http://www.tik.ee.ethz.ch/sop/download/supplementary/testproblems/"; }
+    }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      var evaluators = ApplicationManager.Manager.GetInstances<ZDT>().OrderBy(x => x.Name);
+      return evaluators.Select(x => new MOTFDataDescriptor(x));
+    }
+
+    public override MOTFData LoadData(IDataDescriptor id) {
+      var descriptor = (MOTFDataDescriptor)id;
+      return new MOTFData(descriptor);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Interfaces/IMultiObjectiveTestFunction.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Interfaces/IMultiObjectiveTestFunction.cs	(revision 14064)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Interfaces/IMultiObjectiveTestFunction.cs	(revision 14065)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
   /// <summary>
-  /// An interface which represents an evaluation operator for multi objective test functions.
+  /// An interface which represents an multi objective test functions.
   /// </summary>
   public interface IMultiObjectiveTestFunction : INamedItem {
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/MultiObjectiveTestFunctionProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/MultiObjectiveTestFunctionProblem.cs	(revision 14064)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/MultiObjectiveTestFunctionProblem.cs	(revision 14065)
@@ -186,5 +186,5 @@
 
     public void Load(MOTFData data) {
-      TestFunction = data.Evaluator;
+      TestFunction = data.TestFunction;
     }
 
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/MultiObjectiveTestfunctionTests.csproj
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/MultiObjectiveTestfunctionTests.csproj	(revision 14064)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/MultiObjectiveTestfunctionTests.csproj	(revision 14065)
@@ -9,5 +9,5 @@
     <RootNamespace>MultiObjectiveTestfunctionTests</RootNamespace>
     <AssemblyName>MultiObjectiveTestfunctionTests</AssemblyName>
-    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <ProjectTypeGuids>{3AC096D0-A1C2-E12C-1390-A8335801FDAB};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
@@ -17,4 +17,5 @@
     <IsCodedUITest>False</IsCodedUITest>
     <TestProjectType>UnitTest</TestProjectType>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">