Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/HypervolumeAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 14080)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 14081)
@@ -91,5 +91,5 @@
 
 
-      IEnumerable<double[]> front = NonDominatedSelect.selectNonDominatedVectors(qualities.Select(q => q.ToArray()), testFunction.Maximization(objectives), true);
+      IEnumerable<double[]> front = NonDominatedSelect.SelectNonDominatedVectors(qualities.Select(q => q.ToArray()), testFunction.Maximization(objectives), true);
 
       double hv = front.Any() ? Hypervolume.Calculate(front, testFunction.ReferencePoint(objectives), testFunction.Maximization(objectives)) : 0;
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/NormalizedHypervolumeAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/NormalizedHypervolumeAnalyzer.cs	(revision 14080)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/NormalizedHypervolumeAnalyzer.cs	(revision 14081)
@@ -82,5 +82,5 @@
       }
 
-      IEnumerable<double[]> front = NonDominatedSelect.selectNonDominatedVectors(qualities.Select(q => q.ToArray()), testFunction.Maximization(objectives), true);
+      IEnumerable<double[]> front = NonDominatedSelect.SelectNonDominatedVectors(qualities.Select(q => q.ToArray()), testFunction.Maximization(objectives), true);
 
       if (!results.ContainsKey(resultsHV)) results.Add(new Result(resultsHV, typeof(DoubleValue)));
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Calculators/HyperVolume.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Calculators/HyperVolume.cs	(revision 14080)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Calculators/HyperVolume.cs	(revision 14081)
@@ -53,5 +53,5 @@
     /// 
     public static double Calculate(IEnumerable<double[]> front, double[] referencePoint, bool[] maximization) {
-      front = NonDominatedSelect.removeNonReferenceDominatingVectors(front, referencePoint, maximization, false);
+      front = NonDominatedSelect.GetDominatingVectors(front, referencePoint, maximization, false);
       if (maximization.Length == 2)
         return Calculate2D(front, referencePoint, maximization);
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/NonDominatedSelect.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/NonDominatedSelect.cs	(revision 14080)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/NonDominatedSelect.cs	(revision 14081)
@@ -21,5 +21,4 @@
 
 using System.Collections.Generic;
-using System.Linq;
 
 namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
@@ -28,6 +27,5 @@
     public enum DominationResult { Dominates, IsDominated, IsNonDominated };
 
-    public static IEnumerable<double[]> selectNonDominatedVectors(IEnumerable<double[]> qualities, bool[] maximization, bool dominateOnEqualQualities) {
-      int populationSize = qualities.Count();
+    public static IEnumerable<double[]> SelectNonDominatedVectors(IEnumerable<double[]> qualities, bool[] maximization, bool dominateOnEqualQualities) {
 
       List<double[]> front = new List<double[]>();
@@ -38,5 +36,5 @@
           if (res == DominationResult.Dominates) { insert = false; break; }           //Vector domiates Row
           else if (res == DominationResult.IsDominated) {   //Row dominates Vector
-            front.RemoveRange(i, 1);
+            front.RemoveAt(i);
           }
         }
@@ -49,5 +47,5 @@
     }
 
-    public static IEnumerable<double[]> removeNonReferenceDominatingVectors(IEnumerable<double[]> qualities, double[] reference, bool[] maximization, bool dominateOnEqualQualities) {
+    public static IEnumerable<double[]> GetDominatingVectors(IEnumerable<double[]> qualities, double[] reference, bool[] maximization, bool dominateOnEqualQualities) {
       List<double[]> front = new List<double[]>();
       foreach (double[] vec in qualities) {
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/CrowdingTest.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/CrowdingTest.cs	(revision 14080)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/CrowdingTest.cs	(revision 14081)
@@ -103,5 +103,5 @@
       point3[1] = 2;
       double[][] front = { point, point1, point2, point3 };
-      double dist = Crowding.Calculate(front, new double[,] { { 0, 2 }, { 0, 1 } }); ;
+      double dist = Crowding.Calculate(front, new double[,] { { 0, 2 }, { 0, 1 } });
       Assert.AreEqual(4.5, dist);
     }
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/FastHyperVolumeTests.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/FastHyperVolumeTests.cs	(revision 14080)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/FastHyperVolumeTests.cs	(revision 14081)
@@ -125,5 +125,5 @@
         points.Add(p);
       }
-      var front = NonDominatedSelect.selectNonDominatedVectors(points, maximization, true);
+      var front = NonDominatedSelect.SelectNonDominatedVectors(points, maximization, true);
 
       double dim3hv = Hypervolume.Calculate(front, referencePoint, new bool[3]);
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/HyperVolumeTests.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/HyperVolumeTests.cs	(revision 14080)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/HyperVolumeTests.cs	(revision 14081)
@@ -179,5 +179,5 @@
       referencePoint[0] = 0;
       referencePoint[1] = 1;
-      double nw = Hypervolume.Calculate(NonDominatedSelect.selectNonDominatedVectors(front, maximization, true), referencePoint, maximization);
+      double nw = Hypervolume.Calculate(NonDominatedSelect.SelectNonDominatedVectors(front, maximization, true), referencePoint, maximization);
       Assert.AreEqual(1, nw);
 
@@ -193,5 +193,5 @@
       referencePoint[0] = 1;
       referencePoint[1] = 0;
-      double se = Hypervolume.Calculate(NonDominatedSelect.selectNonDominatedVectors(front, maximization, true), referencePoint, maximization);
+      double se = Hypervolume.Calculate(NonDominatedSelect.SelectNonDominatedVectors(front, maximization, true), referencePoint, maximization);
       Assert.AreEqual(1, se);
 